'use strict';

var language$1 = require('@codemirror/language');
var lr = require('@lezer/lr');
var highlight = require('@lezer/highlight');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const As = 1,
  Since = 2,
  Limit = 3,
  Collate = 4,
  Numeric = 5,
  Asc = 6,
  Desc = 7,
  With = 8,
  Order = 9,
  Omit = 10,
  Where = 11,
  From = 12,
  Split = 13,
  Group = 14,
  Start = 15,
  Timeout = 16,
  Parallel = 17,
  Explain = 18,
  In = 19,
  Then = 20,
  Else = 21,
  End = 22,
  Return = 23,
  Transaction = 24,
  Begin = 25,
  Break = 26,
  Cancel = 27,
  Commit = 28,
  Continue = 29,
  Use = 30,
  Ns = 31,
  Db = 32,
  Throw = 33,
  Sleep = 34,
  Show = 35,
  For = 36,
  Let = 37,
  Info = 38,
  Root = 39,
  Namespace = 40,
  Database = 41,
  Scope = 42,
  Value = 43,
  At = 44,
  By = 45,
  Noindex = 46,
  Index = 47,
  Only = 48,
  Full = 49,
  If = 50,
  True = 51,
  False = 52,
  None = 53,
  Null = 54,
  Comparison = 55,
  And = 56,
  Or = 57,
  Select = 58,
  Changes = 59,
  Table = 60;

const kwmap = new Map([
    [[
            "??", "?:",
            "=", "is",
            "!=", "is not",
            "==",
            "?=", "*=",
            "~", "!~", "?~", "*~",
            "in", "not in",
            "contains", "∋",
            "containsnot", "∌",
            "containsall", "⊇",
            "containsany", "⊃",
            "containsnone", "⊅",
            "inside", "∈",
            "notinside", "not in", "∉",
            "allinside", "⊆",
            "anyinside", "⊂",
            "noneinside", "⊄",
            "outside",
            "intersects",
            "<", ">", "<=", ">=",
            "@@"
        ], Comparison],
    [["&&", "and"], And],
    [["||", "or"], Or],
    [["as"], As],
    [["since"], Since],
    [["limit"], Limit],
    [["collate"], Collate],
    [["numeric"], Numeric],
    [["asc"], Asc],
    [["desc"], Desc],
    [["with"], With],
    [["order"], Order],
    [["omit"], Omit],
    [["where"], Where],
    [["from"], From],
    [["split"], Split],
    [["group"], Group],
    [["start"], Start],
    [["timeout"], Timeout],
    [["parallel"], Parallel],
    [["explain"], Explain],
    [["in"], In],
    [["then"], Then],
    [["else"], Else],
    [["end"], End],
]);
let allkws = [...kwmap.keys()].reduce((a, b) => a.concat(b), []);
const specmap = new Map([
    ["return", Return],
    ["transaction", Transaction],
    ["begin", Begin],
    ["break", Break],
    ["cancel", Cancel],
    ["commit", Commit],
    ["continue", Continue],
    ["use", Use],
    ["ns", Ns],
    ["db", Db],
    ["throw", Throw],
    ["sleep", Sleep],
    ["show", Show],
    ["for", For],
    ["let", Let],
    ["info", Info],
    ["for", For],
    ["root", Root],
    ["namespace", Namespace],
    ["database", Database],
    ["scope", Scope],
    ["value", Value],
    ["at", At],
    ["by", By],
    ["noindex", Noindex],
    ["index", Index],
    ["only", Only],
    ["full", Full],
    ["if", If],
    ["true", True],
    ["false", False],
    ["none", None],
    ["null", Null],
    ["comparison", Comparison],
    ["and", And],
    ["or", Or],
    ["select", Select]
]);
const cspecmap = new Map([
    ["changes", Changes],
    ["table", Table],
]);
function isAlpha(ch) {
    return ch >= 65 /* Ch.A */ && ch <= 90 /* Ch.Z */ || ch >= 97 /* Ch.a */ && ch <= 122 /* Ch.z */ || ch == 95 /* Ch.Underscore */;
}
function isAlphaNum(ch) {
    return ch >= 65 /* Ch.A */ && ch <= 90 /* Ch.Z */ || ch >= 97 /* Ch.a */ && ch <= 122 /* Ch.z */ || ch >= 48 /* Ch._0 */ && ch <= 57 /* Ch._9 */ || ch == 95 /* Ch.Underscore */;
}
function readWord(input, result) {
    for (;;) {
        if (input.next != 95 /* Ch.Underscore */ && !isAlphaNum(input.next))
            break;
        if (result != null)
            result += String.fromCharCode(input.next);
        input.advance();
    }
    return result;
}
function skipSpaces(input) {
    for (;;) {
        if (input.next != 32 /* Ch.Space */ && input.next != 10 /* Ch.Newline */)
            break;
        input.advance();
    }
}
const tokens = new lr.ExternalTokenizer((input, stack) => {
    let { next } = input;
    if (isAlpha(next)) {
        input.advance();
        let word = readWord(input, String.fromCharCode(next)).toLowerCase();
        let word2;
        if (["is", "not"].includes(word)) {
            // needs another word
            skipSpaces(input);
            word2 = readWord(input, "");
            if (!word2)
                return;
            word = word + " " + word2.toLowerCase();
        }
        for (let [kws, token] of kwmap) {
            if (kws.includes(word)) {
                input.acceptToken(token);
                return;
            }
        }
    }
    else {
        // no idea why this doesn't work generally, it fails the parser weirdly.
        // so this is used for special character operators only
        let str = String.fromCharCode(next).toLowerCase();
        while (allkws.find(kw => kw.startsWith(str))) {
            if (allkws.includes(str)) {
                for (let [kws, token] of kwmap) {
                    if (kws.includes(str)) {
                        input.advance();
                        input.acceptToken(token);
                        return;
                    }
                }
            }
            input.advance();
            str += String.fromCharCode(input.next).toLowerCase();
        }
    }
}, { contextual: false });
const specializeIdent = (text, stack) => {
    text = text.toLowerCase();
    if (specmap.has(text)) {
        return specmap.get(text);
    }
    return -1;
};
const extendIdent = (text, stack) => {
    text = text.toLowerCase();
    if (cspecmap.has(text)) {
        return cspecmap.get(text);
    }
    return -1;
};

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,s:137, r:139, d:141, u:143, dec:150, f:155, h:163, m:165, ms:167, us:169, ns:171};
const parser$1 = lr.LRParser.deserialize({
  version: 14,
  states: "!:xO]QQOOO]QQOOP!^OQOOO!cQQO'#DoO#pQQO'#ExOOQO'#Ey'#EyO#pQQO'#EzO#pQQO'#E{OOQO'#E|'#E|O$RQQO'#E}O!cQQO'#FOO!cQQO'#FPO$gQQO'#FQO$lQQO'#FRO$qQQO'#FSO$vQQO'#FTO!cQQO'#FYO!cQQO'#FZOOQO'#Fq'#FqQ&ZQQO'#F_O]QQOOQOQQOOP&`O!bO'#DlPOOO)CAb)CAbO&kOSO'#DpO&vOWO'#DpO'ROQO'#DpO(bQaO'#D|OOQP'#Fx'#FxO*gQQO'#EWO*nQQO'#E[O*vQaO'#E`O-lQQO'#FdO-qQQO'#EwO-vQQO'#E_O-{QQO'#EcO.QQQO'#EdO.VQQO'#EeO.[QQO'#EfO.aQQO'#EnO0UQ`O,5:ZO!cQQO'#EoOOQP'#Ev'#EvOOQP'#Fr'#FrOOOO'#Dq'#DqOOQO'#GR'#GROOQO,5;d,5;dOOQO,5;f,5;fOOQO,5;g,5;gO0fQQO,5;iO0kQQO,5;iO0pQ`O,5;jO1QQ`O,5;kO1bQQO,5;lO1gQQO,5;mO1lQQO,5;nOOQO'#GT'#GTO2TQQO,5;oO2[QaO,5;tO2cQaO,5;uOOQO,5;y,5;yOOQO-E9]-E9]POOO'#F^'#F^P2jO!bO,5:WPOOO,5:W,5:WOOOO'#F`'#F`O2uOSO,5:[OOQP,5:[,5:[OOOO'#Fa'#FaO3QOWO,5:[O2uOSO,5:[O3QOWO,5:[O3]QQO,5:fOOQP,5:i,5:iOOQP,5:c,5:cOOQP,5:f,5:fOOQP'#EO'#EOOOQP,5:r,5:rO3bQ`O,5:rOOQO'#E]'#E]OOQP,5:v,5:vO3lQQO,5:vOOQO,5<O,5<OO3qQaO,5;cOOQO-E9b-E9bO6dQQO,5:yO6iQQO,5:yO!cQQO,5:}OOQP,5;O,5;OO6pQQO,5;PO6uQQO,5;QO7WQ`O,5;YO7_QQO,5;YO7dOQO'#EpO7iQQO,5;ZOOQP,5;Z,5;ZO!cQQO,5;ZO!cQQO,5;ZO!cQQO,5;ZO!cQQO,5;ZO!cQQO,5;ZO!cQQO,5;ZO!cQQO,5;ZO!cQQO,5;ZO7pQaO,5;ZOOQO1G1T1G1TO:]QQO1G1TO:nQQO1G1WO.aQQO1G1XOOQO1G1Y1G1YO!cQQO1G1YO:sQaO'#FUOOQP'#FU'#FUO=TQRO1G1ZO!cQQO1G1`O!cQQO1G1aPOOO-E9[-E9[POOO1G/r1G/rOOOO-E9^-E9^OOQP1G/v1G/vOOOO-E9_-E9_O=[OSO1G/vO=gOWO1G/vO>yQaO1G0QO!cQQO'#FbO@iQQO1G0^OOQP1G0^1G0^O!cQQO1G0bPOQO'#E`'#E`O@qQQO1G0eOOQP1G0e1G0eO@xQ`O1G0eOASQ`O1G0iO!cQQO1G0kOOQP1G0l1G0lOAZQ`O1G0lOA`QpO1G0lOOQP1G0t1G0tOOOO'#Fe'#FeOAeOQO,5;[OOQP,5<Q,5<QODSQaO1G0uP7iQQO1G0uPOQP-E9d-E9dOFvQaO1G0uOF}QaO1G0uOInQaO1G0uOIuQaO1G0uOLiQaO1G0uOLpQaO1G0uOLwQ`O1G0uOMOQQO7+&oO!cQQO7+&rOMTQ`O7+&sOOQO7+&s7+&sOMeQ`O7+&tOMuQQO,5;pO2TQQO'#FgOMzQRO7+&uONRQQO'#GUO! cQRO7+&uO2TQQO7+&uO!!aQ`O7+&zO!!hQaO7+&{OOQP7+%b7+%bOOQP7+%i7+%iOOQP7+%l7+%lO!!rQaO,5;|OOQP-E9`-E9`OOQP7+%x7+%xO!#lQ`O7+%|OOQP7+&P7+&PO!#vQ`O7+&PO!$QQQO7+&POOQP7+&T7+&TO!$YQaO7+&VO!&XQQO7+&WO!&^QQO7+&WOOOO-E9c-E9cOOQO1G0v1G0vP!&cQaO7+&aP!&jQQO'#FfOOQP7+&a7+&aOOQO<<JZ<<JZO!&oQaO<<J^OOQP1G1[1G1[OOQP,5<R,5<ROOQP-E9e-E9eO! cQRO<<JaO2TQQO<<JaOOQO'#GV'#GVO!cQQO,5<pO!'VQQO'#GZO!(SQRO<<JaO<PQRO<<JaO]QQO<<JfO!(^QQO<<JgO!(eQRO<<JgOOQO<<Jg<<JgO*qQQO'#FcO!(mQQO<<IhOOQP<<Ih<<IhO!(uQQO<<IkOOQP<<Ik<<IkOOQP<<Ir<<IrO!cQQOAN?xO!cQQOAN?xO!(}QROAN?{O<PQROAN?{O!)XQQO'#EfO!)^QaO'#GWOOQP'#GW'#GWO!*aQRO1G2[OOQP,5<u,5<uO!+bQQO,5<uO!cQQO'#FXO!+gQQO'#G^O!,wQROAN?{O!+gQQOAN?{O!-fQQOAN?{O!/hQROAN?{O<PQROAN?{O! cQROAN?{O!/rQQOAN@QO]QQOAN@QO!/zQaOAN@RO!cQQO,5<UO!(^QQOAN@ROOQP-E9h-E9hOOQOAN@RAN@RO!0RQQO,5;}OOQO-E9a-E9aOOQPAN?SAN?SOOQPAN?VAN?VO!0WQ`OG25dO!0hQaOG25dO!1^QROG25gO!+gQQOG25gO!-fQQOG25gO!1nQROG25gO<PQROG25gO! cQROG25gO!1xQQO,5;QO!cQQO'#FhO!2dQRO7+'vO!3eQQO1G2aO!3jQaO,5;sOOQO'#G]'#G]O!cQQO,5<xO!4dQQOG25gO!0{QROG25gO!cQQOG25gO!-fQQOG25gO!+gQQOG25gO!cQQOG25gOOQO'#G['#G[O!cQQOG25gO!4uQROG25gOOQOG25lG25lO!5PQQOG25lOOQOG25mG25mO!5XQaO1G1pO!5`QaOG25mP!5gQQO'#FjO!cQQO1G1iO!cQQOLD+OO!5lQQOLD+RO!5}QROLD+RO!cQQOLD+RO!-fQQOLD+RO!+gQQOLD+RO!cQQOLD+RO!cQQOLD+RO!6`QROLD+RO!+gQQOLD+RO!-fQQOLD+RO! cQROLD+RO!6pQROLD+RO!6zQRO'#D|O!8xQaO1G0lO!9SQQO'#E_O!9XQaO1G0lO!9cQaO1G0lO!9mQRO1G1]O!:wQQO1G1]OOQP1G1^1G1^OOQP,5<S,5<SOOQP-E9f-E9fO!;PQQO7+'{O!;UQaO'#G_O!<UQRO1G2dOOQOLD+RLD+RO!<vQaOLD+RO!cQQOLD+RO!cQQOLD+RO!=^QaOLD+RO!>TQaOLD+RO!>zQROLD+ROOQOLD+WLD+WO!cQQO7+'[OOQOLD+XLD+XO!?UQ`O7+'TO!?`Q`O!$'NjOOQO!$'Nm!$'NmO!?pQQO!$'NmO!@RQaO!$'NmO!cQQO!$'NmO!cQQO!$'NmO!=^QaO!$'NmO!@iQaO!$'NmO!A`QRO!$'NmO!cQQO!$'NmO!-fQQO!$'NmO!+gQQO!$'NmO!cQQO!$'NmO!cQQO!$'NmO!AqQRO!$'NmO!A{QRO!$'NmO!+gQQO!$'NmO!-fQQO!$'NmO!B]QRO!$'NmO!BgQQO'#E`O!CpQRO7+&wO!CwQRO7+&wOOQP7+&w7+&wO!DOQRO7+&wOOQP<<Kg<<KgOOQP,5<y,5<yO!DVQRO,5<yO!cQQO'#FiO!D}QRO7+(OO!EoQaO!$'NmO!FYQaO!$'NmO!FvQRO!$'NmO!F}QaO<<JvOOQO!)9DX!)9DXO!GXQQO!)9DXO!GjQRO!)9DXO!G{QaO!)9DXO!HfQaO!)9DXO!FvQRO!)9DXO!ISQRO!)9DXO!+gQQO!)9DXO!HOQaO!)9DXO!cQQO!)9DXO!cQQO!)9DXO!=^QaO!)9DXO!IdQaO!)9DXO!-fQQO!)9DXO!JZQRO!)9DXO!cQQO!)9DXO!-fQQO!)9DXO!+gQQO!)9DXO!cQQO!)9DXO!cQQO!)9DXO!JeQRO1G0QOOQP<<Jc<<JcOOQP1G2e1G2eOOQP,5<T,5<TOOQP-E9g-E9gOOQO!.K9s!.K9sO!JoQQO!.K9sO!KQQRO!.K9sO!cQQO!.K9sO!-fQQO!.K9sO!KcQRO!.K9sO!+gQQO!.K9sO!cQQO!.K9sO!KsQaO!.K9sO!L^QaO!.K9sO!FvQRO!.K9sO!+gQQO!.K9sO!cQQO!.K9sO!-fQQO!.K9sO!KvQaO!.K9sO!cQQO!.K9sO!cQQO!.K9sO!=^QaO!.K9sO!LzQaO!.K9sOOQO!4//_!4//_O!MqQQO!4//_O!NSQaO!4//_O!cQQO!4//_O!NjQRO!4//_O!cQQO!4//_O!-fQQO!4//_O!+gQQO!4//_O!cQQO!4//_O!=^QaO!4//_O!N{QRO!4//_O!cQQO!4//_O# ]QaO!4//_O!cQQO!4//_O#!SQaO!4//_O#!mQaO!4//_O!FvQRO!4//_O!+gQQO!4//_OOQO!9A$y!9A$yO##ZQQO!9A$yO##lQRO!9A$yO##}QaO!9A$yO#$QQaO!9A$yO!cQQO!9A$yO!cQQO!9A$yO#$hQaO!9A$yO!FvQRO!9A$yO#%UQRO!9A$yO!cQQO!9A$yO!-fQQO!9A$yO!+gQQO!9A$yO!=^QaO!9A$yO!+gQQO!9A$yO#%fQaO!9A$yO!cQQO!9A$yOOQO!?$He!?$HeO#&]QQO!?$HeO#&nQRO!?$HeO!cQQO!?$HeO#'PQaO!?$HeO#'jQaO!?$HeO!-fQQO!?$HeO#(WQRO!?$HeO!+gQQO!?$HeO#'SQaO!?$HeO!cQQO!?$HeO!cQQO!?$HeO!FvQRO!?$HeO!cQQO!?$HeO!+gQQO!?$HeO!=^QaO!?$HeOOQO!D6>P!D6>PO#(hQQO!D6>PO#(yQaO!D6>PO#)aQRO!D6>PO!cQQO!D6>PO!-fQQO!D6>PO!cQQO!D6>PO!+gQQO!D6>PO!cQQO!D6>PO#)rQaO!D6>PO#*]QaO!D6>PO#*yQRO!D6>PO!=^QaO!D6>PO!cQQO!D6>PO!FvQRO!D6>POOQO!IH3k!IH3kO#+ZQQO!IH3kO#+lQRO!IH3kO#+}QaO!IH3kO!cQQO!IH3kO#,eQaO!IH3kO!cQQO!IH3kO#-OQaO!IH3kO!cQQO!IH3kO!-fQQO!IH3kO!+gQQO!IH3kO!FvQRO!IH3kO#-lQRO!IH3kO!=^QaO!IH3kOOQO# ,)V# ,)VO#-|QQO# ,)VO#._QRO# ,)VO#.pQaO# ,)VO!cQQO# ,)VO#/ZQaO# ,)VO!-fQQO# ,)VO#.sQaO# ,)VO!cQQO# ,)VO!cQQO# ,)VO#/wQRO# ,)VO!+gQQO# ,)VO!FvQRO# ,)VOOQO#&=Lq#&=LqO#0XQQO#&=LqO#0jQRO#&=LqO!cQQO#&=LqO#0{QaO#&=LqO!-fQQO#&=LqO!cQQO#&=LqO#1cQaO#&=LqO#1|QaO#&=LqO!+gQQO#&=LqO!cQQO#&=LqO#2jQRO#&=LqOOQO#, B]#, B]O#2zQQO#, B]O#3]QaO#, B]O#3sQRO#, B]O!cQQO#, B]O#4UQaO#, B]O!cQQO#, B]O!-fQQO#, B]O!cQQO#, B]O#4oQaO#, B]O!+gQQO#, B]OOQO#137w#137wO#5]QQO#137wO#5nQRO#137wO#6PQaO#137wO!cQQO#137wO#6SQaO#137wO!cQQO#137wO#6jQaO#137wO!-fQQO#137wO!cQQO#137wOOQO#6E-c#6E-cO#7WQQO#6E-cO#7iQRO#6E-cO!cQQO#6E-cO#7zQaO#6E-cO#8bQaO#6E-cO!-fQQO#6E-cO!cQQO#6E-cO#8{QaO#6E-cOOQO#<)!}#<)!}O#9iQQO#<)!}O#9zQaO#<)!}O#:bQRO#<)!}O!cQQO#<)!}O!cQQO#<)!}O#:sQaO#<)!}O!-fQQO#<)!}OOQO#A:Fi#A:FiO#;^QQO#A:FiO#;oQRO#A:FiO#<QQaO#A:FiO#<hQaO#A:FiO!cQQO#A:FiO!cQQO#A:FiOOQO#FL<T#FL<TO#=RQQO#FL<TO#=dQRO#FL<TO!cQQO#FL<TO#=uQaO#FL<TO#>]QaO#FL<TOOQO#L01o#L01oO#>vQQO#L01oO#?XQaO#L01oO#?oQRO#L01oO!cQQO#L01oOOQO$#B'Z$#B'ZO#@QQQO$#B'ZO#@cQRO$#B'ZO#@tQaO$#B'ZOOQO$)%Ju$)%JuO#A[QQO$)%JuO#AmQRO$)%JuOOQO$.7@a$.7@aO#BOQQO$.7@aOOQO$3I5{$3I5{O#BaQQO,5:f",
  stateData: "#Bk~O$aOS!_OS!aQQ~OgROiSOjTOkUOlVOmWOnXOqYOrZOs[Ot`Ou]Ov^O!SaO![_O~O!afO~O!TzO!UzO!V{O!W{O!f|O!g|O!h|O!i|O!ymO!}nO#UwO#iyO$goO$hhO$jiO$mkO$psO$qtO$ruO~Oh}O$O$uP$_$uP#Q$uP!|$uP~Oo!SOp!RO$O#qX$_#qX#Q#qX!|#qX~O!]!VO~O$qtO~Ot!XO~O{!YO!T$wP!U$wP!V$wP!W$wP!f$wP!g$wP!h$wP!i$wP!y$wP!}$wP#U$wP#h$wP#i$wP$g$wP$h$wP$j$wP$m$wP$p$wP$q$wP$r$wP~O$O!^O~O$b!`O$c!`O$d!bO~O!j!cO$h!eO$i!cO~O!j!fO$j!eO$k!fO~O$h!hO$j!iO~O!m!lO!o!mO$O!pX$_!pX!{!pX#Q!pXR!pXW!pXX!pXZ!pX]!pX^!pX_!pX`!pXa!pXb!pX!|!pX~O!f!nO!h!nO!l!jO!s!nO!t!nO!u!nO!v!nO!w!nO!X!pX!Y!pX!Z!pX!y!pX#e!pX#f!pX#g!pX#i!pX$t!pXc!pXd!pX!x!pXP!pXY!pX[!pX!}!pXe!pXf!pXQ!pXS!pXT!pXU!pXV!pX~P'ZO!x!oO~P!cO!|!rO$g!qO~O!X#aX!Y#aX!Z#aX!l#aX!y#aX#U#TX#e#aX#f#aX#g#aX#i#aX$O#aX$_#aX$n#ZX$o#SX$t#aXc#aXd#aX!x#aX!{#aX#Q#aXP#aXR#aXW#aXX#aXY#aXZ#aX[#aX]#aX^#aX_#aX`#aXa#aXb#aX!|#aX!}#aXe#aXf#aXQ#aXS#aXT#aXU#aXV#aX~O$o!tO~O$g!uO~O#U!xO~O!}!yO~O$g!zO~O$g!{O~O$n!|O~OgROiSOjTOkUOlVOmWOnXOqYOrZOs[Ot`Ou]Ov^O!SaO![_O~P!cO!X#UO!Y#SO!Z#TO!l#QO!y#ZO#e#VO#f#WO#g#XO#i#YO$t#PO~O$O!ca$_!ca#Q!ca!|!ca~P/dO$g#]O~O$g#^O~O$O#ra$_#ra#Q#ra!|#ra~P/dO$O#sa$_#sa#Q#sa!|#sa~P/dOt#_O~O$v#`O~Oo#aOp#aOw#aOx#aOy#aOz#bO!^#bO~O#h#dO~P!cOc#fO~P/dOd#gO~P/dO$b!`O$c!`O$d#iO~O!j!cO$h#kO$i!cO~O!j!fO$j#kO$k!fO~O$m#oO~O!x#rO!{#pO~P/dO$n#sO~O!X#ka!Y#ka!Z#ka!l#ka!y#ka#U#TX#e#ka#f#ka#g#ka#i#ka$O#ka$_#ka$o#SX$t#kac#kad#ka!x#ka!{#ka#Q#kaP#kaR#kaW#kaX#kaY#kaZ#ka[#ka]#ka^#ka_#ka`#kaa#kab#ka!|#ka!}#kae#kaf#kaQ#kaS#kaT#kaU#kaV#ka~O#U#uO~O#Q#vO~P!cO$s#yO~O!ymO!}nO#[#{O#_#|O$g#zO~O#Q#}O~P/dO#Q#}O~O$m$OO~O#h$QO~P!cO!y#ZO!X#ca!Y#ca!Z#ca!l#ca#e#ca#f#ca#g#ca#i#ca$O#ca$_#ca$t#cac#cad#ca!x#ca!{#ca#Q#caP#caR#caW#caX#caY#caZ#ca[#ca]#ca^#ca_#ca`#caa#cab#ca!|#ca!}#cae#caf#caQ#caS#caT#caU#caV#ca~Op$]O$O#qi$_#qi#Q#qi!|#qi~O!^$^O~OP$bOR#xXW#xXX#xXY#xXZ#xX[#xX]#xX^#xX_#xX`#xXa#xXb#xX!{#xX$O#xX$_#xX#Q#xX!|#xX~P/dO[$eO!{$cOR$xPW$xPX$xPZ$xP]$xP^$xP_$xP`$xPa$xPb$xP$O$xP$_$xP#Q$xP!|$xP~OY$gO~P<PO!j!cO$h$jO$i!cO~O!j!fO$j$jO$k!fO~O!m$kO!o$lO$O!ni$_!ni!{!ni#Q!niR!niW!niX!niZ!ni]!ni^!ni_!ni`!nia!nib!ni!|!ni~O!X!ni!Y!ni!Z!ni!l!ni!y!ni#e!ni#f!ni#g!ni#i!ni$t!nic!nid!ni!x!niP!niY!ni[!ni!}!nie!nif!niQ!niS!niT!niU!niV!ni~P=rO!x$oO!{#pO~O#Q$qO~P!cO!{#pO#Q$qO~P/dO!|$tO~P/dO#]$vO~O#`$wO~O$m$OO$t$yO~O!y#ZO!X#ci!Y#ci!Z#ci#e#ci#f#ci#g#ci$O#ci$_#ci$t#cic#cid#ci!x#ci!{#ci#Q#ciP#ciR#ciW#ciX#ciY#ciZ#ci[#ci]#ci^#ci_#ci`#cia#cib#ci!|#ci!}#cie#cif#ciQ#ciS#ciT#ciU#ciV#ci~O!l#ci#i#ci~PAmO!X#UO!l#QO!y#ZO#e#VO#f#WO#g#XO#i#YO$t#PO!Z#ci$O#ci$_#cic#cid#ci!x#ci!{#ci#Q#ciP#ciR#ciW#ciX#ciY#ciZ#ci[#ci]#ci^#ci_#ci`#cia#cib#ci!|#ci!}#cie#cif#ciQ#ciS#ciT#ciU#ciV#ci~O!Y#ci~PD^O!Y#SO~PD^O!l#QO!y#ZO#e#VO#f#WO#i#YO!X#ci!Y#ci!Z#ci$O#ci$_#ci$t#cic#cid#ci!x#ci!{#ci#Q#ciP#ciR#ciW#ciX#ciY#ciZ#ci[#ci]#ci^#ci_#ci`#cia#cib#ci!|#ci!}#cie#cif#ciQ#ciS#ciT#ciU#ciV#ci~O#g#XO~PGUO!l#QO#i#YO~PAmO!l#QO!y#ZO#e#VO#i#YO!X#ci!Y#ci!Z#ci#g#ci$O#ci$_#ci$t#cic#cid#ci!x#ci!{#ci#Q#ciP#ciR#ciW#ciX#ciY#ciZ#ci[#ci]#ci^#ci_#ci`#cia#cib#ci!|#ci!}#cie#cif#ciQ#ciS#ciT#ciU#ciV#ci~O#f#ci~PJPO#g#ci~PGUO!x$|O~P/dO$g$}O~O$O#uq$_#uq#Q#uq!|#uq~P/dO$O#vq$_#vq#Q#vq!|#vq~P/dO$g%PO~OY%TO~P<PO!Q%UO!T$yP!U$yP!V$yP!W$yP!f$yP!g$yP!h$yP!i$yP!y$yP!}$yP#U$yP#i$yP$g$yP$h$yP$j$yP$m$yP$p$yP$q$yP$r$yP~OW%WOR$}PX$}PZ$}P]$}P^$}P_$}P`$}Pa$}Pb$}P$O$}P$_$}P#Q$}P!|$}P~O!}%ZO~P/dOe%[Of%^O~P/dO!x$Ua!{$Ua#Q$UaR$UaX$Ua_$Ua`$Uaa$Uab$Ua$O$Ua$_$Ua!|$Ua~P/dO!{%_O!|%aO~P/dO!{#pO#Q%cO~P/dO!{#pO#Q%cO~O$O#Xq$_#Xqc#Xqd#Xq!x#Xq!{#Xq#Q#XqP#XqR#XqW#XqX#XqY#XqZ#Xq[#Xq]#Xq^#Xq_#Xq`#Xqa#Xqb#Xq!|#Xq!}#Xqe#Xqf#XqQ#XqS#XqT#XqU#XqV#Xq~P/dO#^%dO~O#_%dO~O!y#ZO~Q#cq#h$QO~OQ%fOR%eO$O#ty$_#ty#Q#ty!|#ty~P/dO!O%mO!P%nO~OX%pOZ%oOR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~O]%sO^%rO~P!'_O!S%zO~P!cOe%{Of%}O~O!{%_O!|&QO~O!{#pO#Q&RO~O]&WO^&VO~P!'_O$n&[O~OR$zXW$zXX$zXZ$zX]$zX^$zX_$zX`$zXa$zXb$zX!{$zX$O$zX$_$zX#Q$zX!|$zX~P/dO!{&]OR$xiW$xiX$xiZ$xi]$xi^$xi_$xi`$xia$xib$xi$O$xi$_$xi#Q$xi!|$xi~O$g&_O~O}&aO!T%PP!U%PP!V%PP!W%PP!f%PP!g%PP!h%PP!i%PP!y%PP!}%PP#U%PP#i%PP$g%PP$h%PP$j%PP$m%PP$p%PP$q%PP$r%PP~OR&gO_&fO`&eOa&dOb&cO$O#w!R$_#w!R#Q#w!R!|#w!R~O|&iO!T%OP!U%OP!V%OP!W%OP!f%OP!g%OP!h%OP!i%OP!y%OP!}%OP#U%OP#i%OP$g%OP$h%OP$j%OP$m%OP$p%OP$q%OP$r%OP~OX%pOR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~O]&WO^&VO~P!.vO!|&lO$O!^O~Of&nO~P/dO$n&rO~O$O#t!Z$_#t!Z#Q#t!Z!|#t!Z~P/dOR&sO$O#t!Z$_#t!Z#Q#t!Z!|#t!Z~P/dOb&tO$O#w!Z$_#w!Z#Q#w!Z!|#w!Z~OR&xO_&wO`&vOa&uO~P!0{O]&}O^&|O~P!.vO!ymO!}nO#[#{O#_#|O$g'RO$m'QO${'VO$|'VO~O!{&]OR$xqW$xqX$xqZ$xq]$xq^$xq_$xq`$xqa$xqb$xq$O$xq$_$xq#Q$xq!|$xq~O!{'[O~OR#{aX#{a]#{a^#{a_#{a`#{aa#{ab#{a$O#{a$_#{a#Q#{a!|#{a~P/dO!R'_O$O#w!Z$_#w!Z#Q#w!Z!|#w!Z~O]&}O^&|O~P!'_O!|'fO$O!^O~Od'gO~P/dOf'hO~P/dO!S%zO~O!R'kO$O#w!c$_#w!c#Q#w!c!|#w!c~Ob'lO$O#w!c$_#w!c#Q#w!c!|#w!c~OR'uO_'tO`'sOa'rO~P!5}O]'{O^'zO~P!'_O!l,|O${!pX$|!pX~P'ZOR#YiW#YiX#YiZ#Yi]#Yi^#Yi_#Yi`#Yia#Yib#Yi!X#Yi!Y#Yi!Z#Yi!l#Yi!y#Yi!{#Yi#e#Yi#f#Yi#g#Yi#i#Yi$O#Yi$_#Yi$t#Yi#Q#Yi!|#Yi~O#U#TX$o#SX~P!7XO$g'}O~O${(OO$|(OO~P!7XO${(PO$|(PO~P!7XO!ymO!}nO$m'QOR#yiW#yiX#yiZ#yi]#yi^#yi_#yi`#yia#yib#yi!{#yi$O#yi$_#yi#Q#yi!|#yi~O${(RO$|(RO~O$g(SO~OS(UOT(UOU(TOV(TOR%RX_%RX`%RXa%RXb%RX!{%RX$O%RX$_%RX#Q%RX!|%RX~P/dO!{(VOR%Qi_%Qi`%Qia%Qib%Qi$O%Qi$_%Qi#Q%Qi!|%Qi~Oa'rOb'lO$O#w!c$_#w!c#Q#w!c!|#w!c~P/dOX%pO!{#pOR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~P/dOX%pO^'zOR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~P/dO]'{O^'zO~P!.vO!{$Vq!|$Vq~P/dO$O#t!k$_#t!k#Q#t!k!|#t!k~P/dO!R(]O$O#w!k$_#w!k#Q#w!k!|#w!k~Oa(_Ob(^O$O#w!k$_#w!k#Q#w!k!|#w!k~P/dOX%pO^(dOR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~P/dOb(^O$O#w!k$_#w!k#Q#w!k!|#w!k~O](jO^(dO~P!'_OR(nO_(mO`(lOa(_O~P!A`O](jO^(dO~P!.vO#U#TX$o#SX~OR#yqW#yqX#yqZ#yq]#yq^#yq_#yq`#yqa#yqb#yq!{#yq$O#yq$_#yq#Q#yq!|#yq~O!ymO~P!BoO!}nO~P!BoO$m'QO~P!BoOU(sOV(sOR%Ra_%Ra`%Raa%Rab%Ra!{%Ra$O%Ra$_%Ra#Q%Ra!|%Ra~O!{(VOR%Qq_%Qq`%Qqa%Qqb%Qq$O%Qq$_%Qq#Q%Qq!|%Qq~O`(lOa(_Ob(^O$O#w!k$_#w!k#Q#w!k!|#w!k~P/dO_(mO`(lOa(_Ob(^O$O#w!k$_#w!k#Q#w!k!|#w!k~P/dO!{#pO~P!.vOe$^yf$^y~P/dO!R(vO$O#w!s$_#w!s#Q#w!s!|#w!s~Ob(wO$O#w!s$_#w!s#Q#w!s!|#w!s~O`(yOa(xOb(wO$O#w!s$_#w!s#Q#w!s!|#w!s~P/dO_(zO`(yOa(xOb(wO$O#w!s$_#w!s#Q#w!s!|#w!s~P/dOR(|O_(zO`(yOa(xO~P!GjOX%pO^)ROR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~P/dO])TO^)RO~P!.vO${!ni$|!ni~P=rO!R)ZO$O#w!{$_#w!{#Q#w!{!|#w!{~Ob)[O$O#w!{$_#w!{#Q#w!{!|#w!{~OR)bO_)aO`)`Oa)_O~P!KQO`)`Oa)_Ob)[O$O#w!{$_#w!{#Q#w!{!|#w!{~P/dO_)aO`)`Oa)_Ob)[O$O#w!{$_#w!{#Q#w!{!|#w!{~P/dOX%pO^)lOR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~P/dO!R)mO$O#w#T$_#w#T#Q#w#T!|#w#T~Oa)oOb)nO$O#w#T$_#w#T#Q#w#T!|#w#T~P/dOb)nO$O#w#T$_#w#T#Q#w#T!|#w#T~OR)yO_)xO`)wOa)oO~P!NjOX%pO^){OR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~P/dO`)wOa)oOb)nO$O#w#T$_#w#T#Q#w#T!|#w#T~P/dO_)xO`)wOa)oOb)nO$O#w#T$_#w#T#Q#w#T!|#w#T~P/dO!R*OO$O#w#]$_#w#]#Q#w#]!|#w#]~Ob*PO$O#w#]$_#w#]#Q#w#]!|#w#]~O`*ROa*QOb*PO$O#w#]$_#w#]#Q#w#]!|#w#]~P/dO_*UO`*ROa*QOb*PO$O#w#]$_#w#]#Q#w#]!|#w#]~P/dOR*WO_*UO`*ROa*QO~P##lOX%pO^*^OR%QP_%QP`%QPa%QPb%QP$O%QP$_%QP#Q%QP!|%QP~P/dO!R*`O$O#w#e$_#w#e#Q#w#e!|#w#e~Ob*aO$O#w#e$_#w#e#Q#w#e!|#w#e~O`*dOa*cOb*aO$O#w#e$_#w#e#Q#w#e!|#w#e~P/dO_*eO`*dOa*cOb*aO$O#w#e$_#w#e#Q#w#e!|#w#e~P/dOR*gO_*eO`*dOa*cO~P#&nO!R*oO$O#w#m$_#w#m#Q#w#m!|#w#m~Oa*qOb*pO$O#w#m$_#w#m#Q#w#m!|#w#m~P/dOb*pO$O#w#m$_#w#m#Q#w#m!|#w#m~O`*wOa*qOb*pO$O#w#m$_#w#m#Q#w#m!|#w#m~P/dO_*xO`*wOa*qOb*pO$O#w#m$_#w#m#Q#w#m!|#w#m~P/dOR*yO_*xO`*wOa*qO~P#)aO!R*}O$O#w#u$_#w#u#Q#w#u!|#w#u~Ob+OO$O#w#u$_#w#u#Q#w#u!|#w#u~Oa+POb+OO$O#w#u$_#w#u#Q#w#u!|#w#u~P/dO`+ROa+POb+OO$O#w#u$_#w#u#Q#w#u!|#w#u~P/dO_+TO`+ROa+POb+OO$O#w#u$_#w#u#Q#w#u!|#w#u~P/dOR+YO_+TO`+ROa+PO~P#+lO!R+[O$O#w#}$_#w#}#Q#w#}!|#w#}~Ob+]O$O#w#}$_#w#}#Q#w#}!|#w#}~O`+_Oa+^Ob+]O$O#w#}$_#w#}#Q#w#}!|#w#}~P/dO_+aO`+_Oa+^Ob+]O$O#w#}$_#w#}#Q#w#}!|#w#}~P/dOR+eO_+aO`+_Oa+^O~P#._O!R+hO$O#w$V$_#w$V#Q#w$V!|#w$V~Ob+iO$O#w$V$_#w$V#Q#w$V!|#w$V~Oa+kOb+iO$O#w$V$_#w$V#Q#w$V!|#w$V~P/dO`+nOa+kOb+iO$O#w$V$_#w$V#Q#w$V!|#w$V~P/dO_+oO`+nOa+kOb+iO$O#w$V$_#w$V#Q#w$V!|#w$V~P/dOR+rO_+oO`+nOa+kO~P#0jO!R+sO$O#w$_$_#w$_#Q#w$_!|#w$_~Oa+uOb+tO$O#w$_$_#w$_#Q#w$_!|#w$_~P/dOb+tO$O#w$_$_#w$_#Q#w$_!|#w$_~O`+wOa+uOb+tO$O#w$_$_#w$_#Q#w$_!|#w$_~P/dO_+{O`+wOa+uOb+tO$O#w$_$_#w$_#Q#w$_!|#w$_~P/dO!R+}O$O#w$g$_#w$g#Q#w$g!|#w$g~Ob,OO$O#w$g$_#w$g#Q#w$g!|#w$g~O`,QOa,POb,OO$O#w$g$_#w$g#Q#w$g!|#w$g~P/dO_,TO`,QOa,POb,OO$O#w$g$_#w$g#Q#w$g!|#w$g~P/dO!R,WO$O#w$o$_#w$o#Q#w$o!|#w$o~Ob,XO$O#w$o$_#w$o#Q#w$o!|#w$o~Oa,ZOb,XO$O#w$o$_#w$o#Q#w$o!|#w$o~P/dO`,[Oa,ZOb,XO$O#w$o$_#w$o#Q#w$o!|#w$o~P/dO_,_O`,[Oa,ZOb,XO$O#w$o$_#w$o#Q#w$o!|#w$o~P/dO!R,`O$O#w$w$_#w$w#Q#w$w!|#w$w~Oa,bOb,aO$O#w$w$_#w$w#Q#w$w!|#w$w~P/dOb,aO$O#w$w$_#w$w#Q#w$w!|#w$w~O`,eOa,bOb,aO$O#w$w$_#w$w#Q#w$w!|#w$w~P/dO!R,gO$O#w%P$_#w%P#Q#w%P!|#w%P~Ob,hO$O#w%P$_#w%P#Q#w%P!|#w%P~Oa,iOb,hO$O#w%P$_#w%P#Q#w%P!|#w%P~P/dO`,jOa,iOb,hO$O#w%P$_#w%P#Q#w%P!|#w%P~P/dO!R,mO$O#w%X$_#w%X#Q#w%X!|#w%X~Ob,nO$O#w%X$_#w%X#Q#w%X!|#w%X~Oa,pOb,nO$O#w%X$_#w%X#Q#w%X!|#w%X~P/dO`,qOa,pOb,nO$O#w%X$_#w%X#Q#w%X!|#w%X~P/dO!R,rO$O#w%a$_#w%a#Q#w%a!|#w%a~Oa,tOb,sO$O#w%a$_#w%a#Q#w%a!|#w%a~P/dOb,sO$O#w%a$_#w%a#Q#w%a!|#w%a~O!R,vO$O#w%i$_#w%i#Q#w%i!|#w%i~Ob,wO$O#w%i$_#w%i#Q#w%i!|#w%i~Oa,xOb,wO$O#w%i$_#w%i#Q#w%i!|#w%i~P/dO!R,yO$O#w%q$_#w%q#Q#w%q!|#w%q~Ob,zO$O#w%q$_#w%q#Q#w%q!|#w%q~O!R,{O$O#w%y$_#w%y#Q#w%y!|#w%y~O$m(qO~O!a!_#g#f~",
  goto: "!*c%SPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP%TPP%W%a'tPPPPP*XPP*XP*X%a,oPPPPPPP,rPPP/c2SP2Y4p7WP%a9p%a%a<WPPPPP%a%a%a>mPPPPP%a%a%W%W%W%W%W%W%W%W%W%W%W%W@sAPAPAT%W%WPPAdAjAtBOBYC^CdFOFUH`HnHtHzPPPPPPIQIePPPPP!!^PPPPPPPP!$zP!%T!%W!%h!%kPP!%q!&Q!'f!(}!*]RgQ_bOPdw#`%Z%x%s{RYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,q%sjRYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,q%ylRYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&[&]&b&e&h&j&r&s&v&y&z'V'a'b'g'n'o's'v'w(R(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qR!kk%r{RYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qQ#z!|Q'T&[Q(Q'VR(r(O%r{RYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qQ#z!|Q'U&[Q(Q'VR(r(PQ!snR&O%_%r{RYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qR'X&[%ypRYZ`amqwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&[&]&b&e&h&j&r&s&v&y&z'S'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,q%trRYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&[&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qT!wq'S%r{RYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qR!W]%nvRYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%[%e%f%o%z%{&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qT%i%V&]%X#Ux!T!U![!]!p!}#c#w#x$U$V$[$_$a$h$i$m$p$r$u%O%j%y&S&T&`&o&p']'`'c'd'i'j'm'p'q(X(Y([(`(a(e(h(i)O)P)U)X)Y)])d)g)i)j)p)q)t)z)|*S*T*X*_*b*i*j*l*r*t*v*|+Q+S+U+`+c+d+j+m+q+v+x+z,R,S,V,Y,^,c,d,k,l,o,uQ#e!ZQ%Q$cQ%Y$gR%h%TT%k%V&]Q%t%XQ&X%gQ'e&kQ'|'PR(k'xQ!afR#h!aQdOS!_d%xR%x%ZQ!dhS#j!d#mR#m!hQ!giS#l!g#nR#n!iQ#q!ph$n#q$s%b(Z(b)Q)k)u*[*n*z+ZQ$s#wQ%b$rQ(Z'cQ(b'pQ)Q(hQ)k)XQ)u)dQ*[)zQ*n*_Q*z*lR+Z*|Q%`$pR&P%`%rqRYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qS!vq'SR'S&[Q$P#PR$x$P%a#Rx!T!U![!]!p!}#c#w#x$U$V$W$X$Y$Z$[$_$a$h$i$m$p$r$u%O%j%y&S&T&`&o&p']'`'c'd'i'j'm'p'q(X(Y([(`(a(e(h(i)O)P)U)X)Y)])d)g)i)j)p)q)t)z)|*S*T*X*_*b*i*j*l*r*t*v*|+Q+S+U+`+c+d+j+m+q+v+x+z,R,S,V,Y,^,c,d,k,l,o,uQ$d#eU%R$d%u&YQ%u%YR&Y%hQ&^%lR'Z&^Q(W'^R(u(WQ%]$iR%|%]ScOdQePQ#OwQ$`#`Q%w%ZR&m%xQxRQ!TYQ!UZQ![`Q!]aQ!pmQ!}wQ#[yW#c!Z$c$g%TQ#w!xQ#x!yS$R#Q#YQ$U#SQ$V#TQ$W#UQ$X#VQ$Y#WQ$Z#XQ$[#ZQ$_#`Q$a#bQ$h#fQ$i#gQ$m#pQ$p#sQ$r#uQ$u#yQ$z$SQ%O$^S%j%V&]Q%y%[Q&S%eQ&T%fQ&`%oQ&o%zQ&p%{S']&b(VQ'`&eQ'c&hQ'd&jQ'i&rQ'j&sQ'm&vQ'p&yQ'q&zQ(X'aQ(Y'bQ(['gQ(`'nQ(a'oQ(e'sQ(h'vQ(i'wQ)O(fQ)P(gQ)U(lQ)X(oQ)Y(pQ)](yQ)d(}Q)g)SQ)i)VQ)j)WQ)p)^Q)q)`Q)t)cQ)z)fQ)|)hQ*S)rQ*T)sQ*X)wQ*_)}Q*b*RQ*i*YQ*j*ZQ*l*]Q*r*dQ*t*fQ*v*hQ*|*mQ+Q*sQ+S*uQ+U*wQ+`+RQ+c+VQ+d+WQ+j+_Q+m+bQ+q+fQ+v+lQ+x+nQ+z+pQ,R+wQ,S+yQ,V+|Q,Y,QQ,^,UQ,c,[Q,d,]Q,k,eQ,l,fQ,o,jR,u,q%r{RYZ`amwy!Z!x!y#Q#S#T#U#V#W#X#Y#Z#`#b#f#g#p#s#u#y$S$^$c$g%T%V%[%e%f%o%z%{&]&b&e&h&j&r&s&v&y&z'a'b'g'n'o's'v'w(V(f(g(l(o(p(y(})S)V)W)^)`)c)f)h)r)s)w)}*R*Y*Z*]*d*f*h*m*s*u*w+R+V+W+_+b+f+l+n+p+w+y+|,Q,U,[,],e,f,j,qQ'W&[Q(Q'VR(r(RQ!OSQ!PUR!QVR!Z_Q$f#eQ%S$dQ%v%YS&Z%h%uR'O&YR%V$eQ%l%VR'Y&]Q%X$fQ%g%SQ&k%vQ'P&ZR'x'OQ&j%sQ&z&WQ'a&fQ'n&wQ'w&}Q(f'tQ(p'{Q)S(jQ)V(mQ)^(zQ)h)TQ)r)aQ*Y)xQ*f*UQ*s*eQ+V*xQ+b+TQ+l+aQ+y+oQ,U+{Q,],TR,f,_Q&b%pQ&h%rQ&y&VQ'b&gQ'o&xQ'v&|Q(g'uQ(o'zQ(}(dQ)W(nQ)c(|Q)f)RQ)s)bQ)})lQ*Z)yQ*]){Q*h*WQ*m*^Q*u*gQ+W*yQ+f+YQ+p+eR+|+rQ%q%XS&U%g%tS&{&X&kW'y'P'c'd'eY(c'p'q'x'|(ZW({(b(h(i(kU)e)Q)X)YU)v)d)g)kU*V)u)z)|S*k*[*_S*{*l*nS+X*z*|R+g+ZQ'^&bR(t(V",
  nodeNames: "⚠ As Since Limit Collate Numeric Asc Desc With Order Omit Where From Split Group Start Timeout Parallel Explain In Then Else End Return Transaction Begin Break Cancel Commit Continue Use Ns Db Throw Sleep Show For Let Info Root Namespace Database Scope Value At By Noindex Index Only Full If True False None Null Comparison And Or Select Changes Table LineComment BlockComment /* Script ReturnStatement String StringPrefix s r d u Escape Decimal . dec Float f Integer Duration DurationUnit h m ms us ns ] [ Array Comma } { Object Property ) FunctionCall NamespaceId FunctionName ( Future Variable Cast RecordID TableId RIDStart RIDContent RIDEnd RIDDelim RIDDelimContent Column ParenthesizedExpression BinaryExpression ReferencedFulltextOperator Raise DivideOrMultiply AddOrSubtract Star -> Bool Constant BeginStatement BreakStatement CancelStatement CommitStatement ContinueStatement UseStatement ThrowStatement SleepStatement ShowStatement LetStatement InfoStatement SelectStatement Field RecordRange GeneratedRecordID WhereQueryPart ForStatement IfStatement Semi SingleStatement",
  maxTerm: 187,
  nodeProps: [
    ["group", -15,65,120,121,122,123,124,125,126,127,128,129,130,131,136,137,"Statement"],
    ["isolate", 66,""],
    ["openedBy", 86,"[",90,"{",94,"("],
    ["closedBy", 87,"]",91,"}",98,")"]
  ],
  skippedNodes: [0,61,62,63,140],
  repeatNodeCount: 13,
  tokenData: "!$j~R!aOX%WX^'T^p%Wpq'Tqr%Wrs)Ust%Wtu)luw%Wwx*_xy*uyz+hz{,Z{|-w|}.j}!O/]!O!P5R!P!Q7f!Q![9W![!]:P!]!^;k!^!_<^!_!`Bp!`!aCc!a!b%W!b!cDU!c!}Dw!}#OFS#O#PFu#P#QI[#Q#RI}#R#SDw#S#TMY#T#oDw#o#pNZ#p#q%W#q#rN|#r#y%W#y#z'T#z$f%W$f$g'T$g%o%W%o%p! o%p&a%W&a&b! o&b#BY%W#BY#BZ'T#BZ$IS%W$IS$I_'T$I_$I|%W$I|$JO'T$JO$JT%W$JT$JU'T$JU$KV%W$KV$KW'T$KW%GS%W%GS%GT!!b%GT%GU!#f%GU&FU%W&FU&FV'T&FV;'S%W;'S;=`&}<%lO%W[%_W$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%WW%|T$kWOw%wx#O%w#P;'S%w;'S;=`&]<%lO%wW&`P;=`<%l%wS&hT$iSOr&cs#O&c#P;'S&c;'S;=`&w<%lO&cS&zP;=`<%l&c['QP;=`<%l%W!`'^l$iS$kW$a!SOX%WX^'T^p%Wpq'Tqr%Wrs%wsw%Wwx&cx#O%W#P#y%W#y#z'T#z$f%W$f$g'T$g#BY%W#BY#BZ'T#BZ$IS%W$IS$I_'T$I_$I|%W$I|$JO'T$JO$JT%W$JT$JU'T$JU$KV%W$KV$KW'T$KW&FU%W&FU&FV'T&FV;'S%W;'S;=`&}<%lO%W^)]T$hU$kWOw%wx#O%w#P;'S%w;'S;=`&]<%lO%w^)uW$qQ$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W^*fT$jY$iSOr&cs#O&c#P;'S&c;'S;=`&w<%lO&cn+OW#Ub$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wn+qW#Qb$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wn,fY#hQ$iS$kW#f`Or%Wrs%wsw%Wwx&cxz%Wz{-U{#O%W#P;'S%W;'S;=`&}<%lO%Wl-_W#e`$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wl.QW$iS$kW#g`Or%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wn.sW!{b$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W!`/f[$iS$kW#g`Or%Wrs%wsw%Wwx&cx}%W}!O0[!O!`%W!`!a4`!a#O%W#P;'S%W;'S;=`&}<%lO%W!`0cY$iS$kWOp%Wpq1Rqr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W!`1[Z$iS$kW!_!SOY1RYZ%WZr1Rrs1}sw1Rwx3`x#O1R#O#P2q#P;'S1R;'S;=`4Y<%lO1R![2UX$kW!_!SOY1}YZ%wZw1}wx2qx#O1}#O#P2q#P;'S1};'S;=`3Y<%lO1}!S2vS!_!SOY2qZ;'S2q;'S;=`3S<%lO2q!S3VP;=`<%l2q![3]P;=`<%l1}!W3gX$iS!_!SOY3`YZ&cZr3`rs2qs#O3`#O#P2q#P;'S3`;'S;=`4S<%lO3`!W4VP;=`<%l3`!`4]P;=`<%l1Rn4iW#ib$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wn5[Y!lb$iS$kWOr%Wrs%wsw%Wwx&cx!O%W!O!P5z!P#O%W#P;'S%W;'S;=`&}<%lO%Wn6TY${b$iS$kWOr%Wrs%wsw%Wwx&cx!_%W!_!`6s!`#O%W#P;'S%W;'S;=`&}<%lO%Wn6|W$|b$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W!`7o[$iS$kW#f`Or%Wrs%wsw%Wwx&cxz%Wz{8e{!P%W!P!Q1R!Q#O%W#P;'S%W;'S;=`&}<%lO%W!`8nW$iS$kW!a!SOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W^9aY$mQ$iS$kWOr%Wrs%wsw%Wwx&cx!Q%W!Q![9W![#O%W#P;'S%W;'S;=`&}<%lO%Wn:YY$nb$iS$kWOr%Wrs%wsw%Wwx&cx![%W![!]:x!]#O%W#P;'S%W;'S;=`&}<%lO%Wn;RW$ob$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wn;tW$Ob$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W^<gY$rQ$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#Y%W#Y#Z=V#Z;'S%W;'S;=`&}<%lO%W^=^Y$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#i%W#i#j=|#j;'S%W;'S;=`&}<%lO%W^>TY$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#h%W#h#i>s#i;'S%W;'S;=`&}<%lO%W^>zY$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#i%W#i#j?j#j;'S%W;'S;=`&}<%lO%W^?qY$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#f%W#f#g@a#g;'S%W;'S;=`&}<%lO%W^@hY$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#X%W#X#YAW#Y;'S%W;'S;=`&}<%lO%W^A_Y$iS$kWOr%Wrs%wsw%Wwx&cx!`%W!`!aA}!a#O%W#P;'S%W;'S;=`&}<%lO%W^BWW$pQ$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W^ByW$vQ$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W^ClW$sQ$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%WnD_W$tb$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%WnEQ`$gb$iS$kWOr%Wrs%wsw%Wwx&cx!Q%W!Q![Dw![!c%W!c!}Dw!}#O%W#P#R%W#R#SDw#S#T%W#T#oDw#o;'S%W;'S;=`&}<%lO%WnF]W!yb$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W~FxVO#iG_#i#jGd#j#lG_#l#mHP#m;'SG_;'S;=`IU<%lOG_~GdO!j~~GgS!Q![Gs!c!iGs#T#ZGs#o#pHi~GvR!Q![HP!c!iHP#T#ZHP~HSR!Q![H]!c!iH]#T#ZH]~H`R!Q![G_!c!iG_#T#ZG_~HlR!Q![Hu!c!iHu#T#ZHu~HxS!Q![Hu!c!iHu#T#ZHu#q#rG_~IXP;=`<%lG_nIeW!xb$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%W!^JY_#]`#`p$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#Q%W#Q#RI}#R#S%W#S#TKX#T%GS%W%GS%GTLW%GT%GULW%GU;'S%W;'S;=`&}<%lO%W|Kb[#`p$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#Q%W#Q#RKX#R#S%W#S#TKX#T;'S%W;'S;=`&}<%lO%WlLa]#]`$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#Q%W#Q#RLW#R%GS%W%GS%GTLW%GT%GULW%GU;'S%W;'S;=`&}<%lO%W!OMe[#_Q#`p$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#Q%W#Q#RKX#R#S%W#S#TKX#T;'S%W;'S;=`&}<%lO%WnNdW!}b$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wn! VW!|b$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wl! xW$iS$kW#f`Or%Wrs%wsw%Wwx&cx#O%W#P;'S%W;'S;=`&}<%lO%Wn!!m]#]`#[Q$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#Q%W#Q#RLW#R%GS%W%GS%GTLW%GT%GULW%GU;'S%W;'S;=`&}<%lO%Wn!#q]#]`#^Q$iS$kWOr%Wrs%wsw%Wwx&cx#O%W#P#Q%W#Q#RLW#R%GS%W%GS%GTLW%GT%GULW%GU;'S%W;'S;=`&}<%lO%W",
  tokenizers: [tokens, 1, 2, 3, 4, 5, new lr.LocalTokenGroup("j~RQYZXz{^~^O$c~~aP!P!Qd~iO$d~~", 25, 156)],
  topRules: {"Script":[0,64],"SingleStatement":[1,139]},
  specialized: [{term: 161, get: (value, stack) => (specializeIdent(value) << 1), external: specializeIdent},{term: 161, get: (value, stack) => (extendIdent(value) << 1) | 1, external: extendIdent, extend: true},{term: 161, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 5772
});

let parser = parser$1.configure({
    props: [
        language$1.foldNodeProp.add({
            BlockComment(tree) { return { from: tree.from + 2, to: tree.to - 2 }; }
        }),
        language$1.indentNodeProp.add({
            Statement: language$1.continuedIndent()
        }),
        highlight.styleTags({
            "StringPrefix As Asc Desc Collate Numeric": highlight.tags.keyword,
            "Select From Where Group By Having Order Limit Return Transaction Begin Break Cancel Commit Continue Use Db Ns Sleep Show Changes For Table Since Info Namespace Database Scope Table Value At With Noindex Index Only Omit Split Start Timeout Parallel Explain Full In": highlight.tags.keyword,
            Escape: highlight.tags.escape,
            Bool: highlight.tags.bool,
            "DivideOrMultiply AddOrSubtract": highlight.tags.arithmeticOperator,
            "let <future>": highlight.tags.definitionKeyword,
            NamespaceId: highlight.tags.namespace,
            FunctionName: highlight.tags.function(highlight.tags.variableName),
            Variable: highlight.tags.variableName,
            Star: highlight.tags.atom,
            Integer: highlight.tags.integer,
            "Decimal Float": highlight.tags.float,
            Duration: highlight.tags.number,
            LineComment: highlight.tags.lineComment,
            BlockComment: highlight.tags.blockComment,
            String: highlight.tags.string,
            Constant: highlight.tags.constant(highlight.tags.variableName),
            "Return Break ForStatement/For If Else Then": highlight.tags.controlKeyword,
            "DurationUnit": highlight.tags.unit,
            "None Null": highlight.tags.null,
            "RecordID": highlight.tags.special(highlight.tags.variableName),
            "Comparison @": highlight.tags.compareOperator,
            "And Or": highlight.tags.logicOperator,
            "BinaryExpression/. ->": highlight.tags.derefOperator,
            ": :: ..=": highlight.tags.punctuation,
            "Column Property": highlight.tags.propertyName,
            "Semi Comma": highlight.tags.separator,
            "( )": highlight.tags.paren,
            "{ }": highlight.tags.brace,
            "[ ]": highlight.tags.squareBracket,
            "< >": highlight.tags.angleBracket,
        })
    ]
});
const language = language$1.LRLanguage.define({
    name: "surrealql",
    parser: parser,
    languageData: {
        commentTokens: { line: "//", block: { open: "/*", close: "*/" } },
        closeBrackets: {
            brackets: ["(", "[", "{", "'", '"', "`"]
        }
    }
});
function surrealql() {
    return new language$1.LanguageSupport(language, []);
}

exports.baseParser = parser$1;
exports.language = language;
exports.parser = parser;
exports.surrealql = surrealql;
